// ******************************************************************
// *
// *  Sirenic is free software; you can redistribute it and/or modify
// *  it under the terms of the GNU General Public License as published
// *  by the Free Software Foundation; either version 2 of the license,
// *  or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2004 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************

#include "CMachine.h"

#include <math.h>

CMachine::CMachine() : pNodeH(0), pNodeT(0), pConnH(0), pConnT(0)
{
}

CMachine::~CMachine()
{
    /*! remove all connections */
    CMachineConnList *pCurConn = pConnH;

    while(pCurConn != 0)
    {
        CMachineConnList *pDelConn = pCurConn;

        pCurConn = pCurConn->pNext;

        delete pDelConn;
    }

    /*! remove all nodes */
    CMachineNodeList *pCurNode = pNodeH;

    while(pCurNode != 0)
    {
        CMachineNodeList *pDelNode = pCurNode;

        pCurNode = pCurNode->pNext;

        delete pDelNode;
    }
}

void CMachine::InsertNode(CMachineNodeList *pNode)
{
    if(pNodeT == 0) { pNodeH = pNodeT = pNode; }
    else { pNodeT = pNodeT->pNext = pNode; }

    return;
}

void CMachine::InsertConn(CMachineConnList *pConn)
{
    if(pConnT == 0) { pConnH = pConnT = pConn; }
    else { pConnT = pConnT->pNext = pConn; }

    return;
}
