// ******************************************************************
// *
// *  Sirenic is free software; you can redistribute it and/or modify
// *  it under the terms of the GNU General Public License as published
// *  by the Free Software Foundation; either version 2 of the license,
// *  or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2004 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************

#ifndef CMACHINE_BOX_H
#define CMACHINE_BOX_H

#include "CMachine.h"

/*! @brief Box Machine
 * 
 * Represents a "Box" machine. This type of machine consists of 4 nodes
 * and 4-6 connectors. The shape of this machine is initially square.
 *
 */

class CMachine_Box : public CMachine
{
    public:

        /*! 
         *
         * @param fPosX The center X position of this box.
         * @param fPosY The center Y position of this box.
         * @param fSideLength The length of each connector.
         * @param bReinforced Determines if this box should be reinforced by using 6 instead of 4 connectors.
         *
         */

        CMachine_Box(float fPosX, float fPosY, float fSideLength = 0.05f, bool bReinforced = true);
};

#endif
