// ******************************************************************
// *
// *  Sirenic is free software; you can redistribute it and/or modify
// *  it under the terms of the GNU General Public License as published
// *  by the Free Software Foundation; either version 2 of the license,
// *  or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2004 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************

#ifndef CMACHINE_CHAIN_H
#define CMACHINE_CHAIN_H

#include "CMachine.h"

/*! @brief Chain machine
 * 
 * Represents a "Chain" machine. This type of machine consists of n nodes
 * and n-1 connectors. The shape of this machine is initially a straight line.
 *
 */

class CMachine_Chain : public CMachine
{
    public:

        /*! 
         *
         * @param fPosX The center X position of this chain.
         * @param fPosY The center Y position of this chain.
         * @param fConnLengthX The length of each connector, in the X direction.
         * @param fConnLengthY The length of each connector, in the Y direction.
         * @param uiNodeCount The number of nodes to construct.
         *
         */

        CMachine_Chain(float fPosX, float fPosY, float fConnLengthX = 0.05f, float fConnLengthY = 0.05f, uint32 uiNodeCount = 5);
};

#endif
