// ******************************************************************
// *
// *  Sirenic is free software; you can redistribute it and/or modify
// *  it under the terms of the GNU General Public License as published
// *  by the Free Software Foundation; either version 2 of the license,
// *  or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2004 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************

#ifndef CRENDERDD4_H
#define CRENDERDD4_H

#include "CRender.h"

#include <windows.h>
#include <ddraw.h>

/*! @brief DirectDraw4 Windowed Renderer */
class CRenderDD4 : public CRender
{
    public:
        
        CRenderDD4(uint width, uint height, HWND hWnd);
       ~CRenderDD4();

        bool Create();

        bool RenderPixels(uint08 *pPixels);

        bool RotatePalette();

        uint32 *GetColorTable() { return this->pColorTable; }

    private:

        static void fpcRGB32(void *pContext, uint32 i, float r, float g, float b);

        HWND hWnd;

        IDirectDraw            *pDirectDraw;
        IDirectDraw4           *pDirectDraw4;
        IDirectDrawSurface4    *pDD4SPrimary;
        IDirectDrawSurface4    *pDD4SBackBuffer;
        IDirectDrawClipper     *pDD4Clipper;

        //
        // palette
        //

        uint32 *pColorTable;
        uint32 *pColorTableBack;

        //
        // palette rotation
        //

        uint32 rotPaletteOffset;
};

#endif
