// ******************************************************************
// *
// *  Sirenic is free software; you can redistribute it and/or modify
// *  it under the terms of the GNU General Public License as published
// *  by the Free Software Foundation; either version 2 of the license,
// *  or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2004 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************

#ifndef CRENDERXBOX_H
#define CRENDERXBOX_H

#include "CRender.h"

#include <xtl.h>

class CRenderXbox : public CRender
{
    public:
        
        CRenderXbox(uint width, uint height);

       ~CRenderXbox();

        bool Create();

        bool RenderPixels(uint08 *pPixels);

        bool RotatePalette();

        uint32 *GetColorTable() { return this->pColorTable; }

    private:

        static void fpcRGB32(void *pContext, uint32 i, float r, float g, float b);

        IDirect3D8             *pDirect3D8;
        IDirect3DDevice8       *pDirect3DDevice8;

        //
        // palette
        //

        uint32 *pColorTable;
        uint32 *pColorTableBack;

        //
        // palette rotation
        //

        uint32 rotPaletteOffset;
};

#endif
