// ******************************************************************
// *
// *  Sirenic is free software; you can redistribute it and/or modify
// *  it under the terms of the GNU General Public License as published
// *  by the Free Software Foundation; either version 2 of the license,
// *  or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2004 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************

#include "Event.h"
#include "Mutex.h"

#ifdef _XBOX
#include <xtl.h>
#else
#include <windows.h>
#endif

Event::Event(bool manualReset)
{
    BOOL bManualReset = manualReset ? TRUE : FALSE;

    pEvent = CreateEvent(NULL, bManualReset, FALSE, NULL);
}

Event::~Event()
{
    CloseHandle(this->pEvent);
}

void Event::Wait()
{
    WaitForSingleObject(this->pEvent, INFINITE);
}

void Event::Set()
{
    SetEvent(this->pEvent);
}

void Event::Reset()
{
    ResetEvent(this->pEvent);
}
