// ******************************************************************
// *
// *  Sirenic is free software; you can redistribute it and/or modify
// *  it under the terms of the GNU General Public License as published
// *  by the Free Software Foundation; either version 2 of the license,
// *  or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2004 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************

#include "Mutex.h"

#ifdef _XBOX
#include <xtl.h>
#else
#include <windows.h>
#endif

Mutex::Mutex()
{
    this->pMutex = new CRITICAL_SECTION();

    InitializeCriticalSection((CRITICAL_SECTION*)this->pMutex);
}

Mutex::~Mutex()
{
    DeleteCriticalSection((CRITICAL_SECTION*)this->pMutex);

    if(this->pMutex != NULL) { delete this->pMutex; }
}

void Mutex::Wait()
{
    EnterCriticalSection((CRITICAL_SECTION*)this->pMutex);
}

void Mutex::Release()
{
    LeaveCriticalSection((CRITICAL_SECTION*)this->pMutex);
}
