// ******************************************************************
// *
// *  Sirenic is free software; you can redistribute it and/or modify
// *  it under the terms of the GNU General Public License as published
// *  by the Free Software Foundation; either version 2 of the license,
// *  or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2004 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************

#ifndef RENDERWND_H
#define RENDERWND_H

#include "Wnd.h"

class RenderWnd : public Wnd
{
    public:

        RenderWnd(uint width, uint height, bool bPopup = false);

        virtual ~RenderWnd();

        uint GetMousePosX() { return this->mouseX; }
        uint GetMousePosY() { return this->mouseY; }

        bool GetMouseDownL() { return this->mouseDownL; }

        // window message handling procedure
        virtual LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

    protected:

        uint mouseX, mouseY;

        UINT_PTR timerID;

        int curTick;

        bool mouseDownL;

        RECT cachedRect;

        bool isMaximized;
};

#endif
