// ******************************************************************
// *
// *  Sirenic is free software; you can redistribute it and/or modify
// *  it under the terms of the GNU General Public License as published
// *  by the Free Software Foundation; either version 2 of the license,
// *  or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2004 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************

#ifndef WND_H
#define WND_H

#include <windows.h>

#include "BaseTypes.h"

class Wnd
{
    public:

        Wnd();

        virtual ~Wnd();

        // called first to create window
        bool Create();

        // should be called frequently
        bool ProcessMessages();

        // forward window messages
        static  LRESULT CALLBACK WndProcForward(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

        // window message handling procedure
        virtual LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

        void Show() { ShowWindow(this->hWnd, SW_NORMAL); }
        void Hide() { ShowWindow(this->hWnd, SW_HIDE); }

        // retrieve window handle
        HWND GetWnd() { return this->hWnd; }

        // retrieve width/height
        int GetWidth() { return this->width; }
        int GetHeight() { return this->height; }

        // is this window created yet?
        bool isCreated() { return this->bCreated; }

    protected:
 
        HWND        hWnd, hParentWnd;
        ATOM        wClass;

        const char *szClassName;
        const char *szWindowName;

        UINT        uiClassStyle;
        DWORD       dwWindowStyle;

        int         x, y, width, height;

        HICON       hIcon;

        HBRUSH      hBgBrush;

        bool        bCreated;

    private:
};

#endif
