// ******************************************************************
// *
// *  Sirenic is free software; you can redistribute it and/or modify
// *  it under the terms of the GNU General Public License as published
// *  by the Free Software Foundation; either version 2 of the license,
// *  or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2004 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************

#ifndef FX_POLYDANCE_H
#define FX_POLYDANCE_H

#include "RenderFX.h"
#include "Transform.h"

/*! @brief Dancing polygon rendering effect */
class FX_PolyDance : public RenderFX
{
    public:

        /*! Construct dancing polygon effect using the specified configuration */
        FX_PolyDance(Sirenic *pSirenic, float poss, float scaleX, float scaleXs, float scaleY, float scaleYs, float c, float cs);

        /*! Perform rendering */
        bool Render();

        /*! Increment state machine one step */
        bool Step();

    private:

        /*! current position within trig function */
        float pos;

        /*! current acceleration of position within trig function */
        float poss;

        float cx, cy;

        /*! current color */
        float c;
        
        /*! acceleration of current color */
        float cs;

        /*! current scale X component */
        float scaleX;

        /*! current scale Y component */
        float scaleY;

        /*! current scale acceleration X component */
        float scaleXs;

        /*! current scale acceleration Y component */
        float scaleYs;
};

#endif
