// ******************************************************************
// *
// *  Sirenic is free software; you can redistribute it and/or modify
// *  it under the terms of the GNU General Public License as published
// *  by the Free Software Foundation; either version 2 of the license,
// *  or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2004 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************

#ifndef TRANSFORM_H
#define TRANSFORM_H

#include "BaseTypes.h"
#include "CartCoord.h"

#include <math.h>

/*! Simple cartesian transformation function pointer */
typedef void (*CartesianTransformFunc)(float fX, float &fY);

/*! Simple Y = X formula */
static void CTF_YEQX(float fX, float &fY) { fY = fX; }

static void CTF_SPIN_X(float fX, float &fY) { fY = 0.5f + sinf(fX*3.1415f)/4; }
static void CTF_SPIN_Y(float fX, float &fY) { fY = 0.5f + cosf(fX*3.1415f)/4; }
static void CTF_SPIN_NEG_X(float fX, float &fY) { fY = 0.5f - sinf(fX*3.1415f)/4; }
static void CTF_SPIN_NEG_Y(float fX, float &fY) { fY = 0.5f - cosf(fX*3.1415f)/4; }

#endif
