// ******************************************************************
// *
// *  Sirenic is free software; you can redistribute it and/or modify
// *  it under the terms of the GNU General Public License as published
// *  by the Free Software Foundation; either version 2 of the license,
// *  or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2004 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************

#include "WinampRenderWnd.h"

WinampRenderWnd::WinampRenderWnd(uint width, uint height, HWND hParentWnd) : mouseX(width/2), mouseY(height/2), mouseDownL(false), isMaximized(false)
{
    this->szClassName = "WinampRenderWnd";
    this->szWindowName = "Sirenic Render Window";

    this->width = width;
    this->height = height;

    this->uiClassStyle |= CS_DBLCLKS;

    this->dwWindowStyle = WS_CLIPCHILDREN | WS_CLIPSIBLINGS | WS_CHILDWINDOW;

    this->hParentWnd = hParentWnd;

    return;
}

WinampRenderWnd::~WinampRenderWnd()
{
}

LRESULT CALLBACK WinampRenderWnd::WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch(uMsg)
    {
        case WM_MOUSEMOVE:
        {
            this->mouseX = LOWORD(lParam);
            this->mouseY = HIWORD(lParam);
        }
        break;

        case WM_SIZE:
        {
            RECT Rect;

            GetClientRect(hWnd, &Rect);

            this->width  = Rect.right;
            this->height = Rect.bottom;
        }
        break;

        case WM_LBUTTONDOWN:
        {
            this->mouseDownL = true;
        }
        break;

        case WM_LBUTTONUP:
        {
            this->mouseDownL = false;
        }
        break;

        case WM_LBUTTONDBLCLK:
        {
            if(this->isMaximized)
            {
                SetParent(hWnd, this->hParentWnd);

                this->isMaximized = false;
            }
            else
            {
                SetParent(hWnd, NULL);

                SetWindowLong(hWnd, GWL_STYLE, WS_POPUP);
                ShowWindow(hWnd, SW_MAXIMIZE);
                SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
                SetFocus(hWnd);

                this->isMaximized = true;
            }
        }
        break;
    }

    return Wnd::WndProc(hWnd, uMsg, wParam, lParam);
}
