// ******************************************************************
// *
// *  Sirenic is free software; you can redistribute it and/or modify
// *  it under the terms of the GNU General Public License as published
// *  by the Free Software Foundation; either version 2 of the license,
// *  or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2004 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************

#ifndef VIS_SIRENIC_H
#define VIS_SIRENIC_H

#include <windows.h>

#include "Sirenic.h"
#include "WinampRenderWnd.h"
#include "CRenderDX9.h"

#include "wa_ipc.h"
#include "VIS.H"

class vis_sirenic
{
    public:

        vis_sirenic(winampVisModule *pVisModule);
       ~vis_sirenic();

        // called first for initialization
        bool Create();

        // has this class been created yet?
        bool isCreated() { return this->bCreated; }

        // render a frame
        void Render();

    private:

        Sirenic         *pSirenic;
        WinampRenderWnd *pWindow;
        CRenderDX9      *pRenderDX9;

        winampVisModule *pVisModule;

        embedWindowState windowState;

        // has this class been created yet?
        bool bCreated;
};

#endif
